#include "partition.h"
#include <bits/stdc++.h>
using namespace std;

#define ff first
#define sc second
#define ll long long
#define pb push_back
#define all(x) (x).begin(),(x).end()

const int maxN = 2 * 1e5;

int get(ll x) {
    int cnt = 0;
    while (x % 2 == 0) {
        cnt++; x /= 2;
    }
    return cnt;
}
std::vector<int> solve(std::vector<int> arr) {
    int n = arr.size(); vector<int> ans;
    
    int cnt[26]; vector<int> pos[26];
    for (int i = 0; i < arr.size(); i++) {
        cnt[get(arr[i])]++; pos[get(arr[i])].pb(i);
    }

    vector<int> odd;
    for (int i = 0; i < 26; i++) {
        for (int j = 0; j < cnt[i] / 2; j++) ans.pb(pos[i][j]);
        if (cnt[i] % 2 == 1) odd.pb(pos[i][cnt[i] / 2]);
    } reverse(all(odd));

    while ((int)ans.size() + 1 < n / 2) {
        ans.pb(odd.back()); odd.pop_back();
    } ans.pb(odd[0]);

    bool did[n]{};
    for (int i : ans) did[i] = 1;
    for (int i = 0; i < n; i++) if (!did[i]) ans.pb(i);
    return ans;
}


// int main () {
//     ios_base::sync_with_stdio(false);
//     cin.tie(NULL);
//     int t;
//     cin >> t ;
//     for (int test=1; test<=t; test++) {
//         int n;
//         cin >> n ;
//         vector <int> a(n);
//         for (int i=0; i<n; i++) {
//             cin >> a[i] ;
//         }

//         for (auto ind : solve(a)) {
//             cout << ind << " ";
//         }
//         cout << endl ;
//     }
//     cout << endl ;
//     return 0;
// }
